Astonio Framework
=================

**Simple and powerful open-source JavaScript framework for generating data management applications based on any data sources.**

How it works
------------

Astonio framework works with any data source (be it a database server or any server application serving as a source of data and coded in any programming language).

The framework provides:

 - Mechanisms for data objects interaction and displaying these interactions in your interface.
 - Backend serving as a bridge between the framework and your data source.
 - Automatically generated forms (lists, records, filters) and interactive control elements for data processing.

On top of that, there is a vast set of tools that enables you to build the precise application you need. In addition, you can extend the framework itself or implement the modules created by other developers.

You can flexibly configure data source using the language of your preference. The framework interacts with the data source using a corresponding backend module. It defines all the logics for how data received from the data source is to be processed and what data is to be sent back to them. In the backend you define a communication protocol with the data source. Alternatively you are going to be able to download and set up the pre-built backends that are going to be available for various data source types.

Once our framework has generated an application, you may wish to keep it as it is, or code new extensions to it. You can enhance the interface to meet your needs by using our set of JavaScript modules and functions, and you can extend the data source server's logics in your programming language. The framework provides you with the choice: to develop an interface or its part quicker yet less flexibly, or do it slower yet create a more functional interface.

QuickStart
----------
http://astonio.com/framework/quickstart/